﻿Type=Class
Version=3.8
B4A=true
@EndOfDesignText@
'Class module
'Events declaration
' Class to manage input sliders (similar to Seekbar) that allows use of images
Sub Class_Globals

	Private FACTOR_BG As Float = 0.8			'just in case we draw the default colors (not image)
												'This allows the visible bar to be thinner than the pointer
												'f.i., 1.0: Full widht/Height, 0.6: 60% width/height
												
	Private FACTOR_PTR As Float = 1.0			' Distance from begin and end to pointer center measured in multiples of pointer radius size
												' 1.0: fits exactly
												' 1.5: we leave half pointer radius additional distance before start and before end


	'***************************************************************************
	
	Private MaxPtrs As Int = 3				'Maximum number of allowed pointers
	Private NumPtrs As Int					'Number of pointers 

	Private PtrPos(MaxPtrs) As Double
	Private BarBGOrient As Boolean			' True = Vertical False = Horizontal
	Private MaxVal,MaxMove As Int
	Private BarBG As Panel
	Private Ptr(MaxPtrs) As Panel
	Private ISName As String
	Private CF As Object
	Private Version As String
	Private Rangebar As Panel
	Private InInit As Boolean
	'Private is_discrete As Boolean
	Private index As Int=0
	Private permis_callsub As Boolean=True
	Private CX_INI,CX_END,CY_INI,CY_END As Float
	Private RECORREGUT As Int
	Private act As Activity
	Private SliderColor As Int
	
	Private IsEnabled As Boolean
	Private IsDiscrete As Boolean
	Private ReverseDir As Boolean
	
End Sub

'Initializes the slider
Public Sub Initialize (Target As Object, EventName As String)
	ISName = EventName
	CF = Target
End Sub

Public Sub DesignerCreateView(base As Panel, lbl As Label, props As Map)
	
	Version = "1.05"

	InInit = True 'just a flag to prevent the connecting line being drawn while the sliders are created
	act = props.Get("activity")
	SliderColor = Colors.RGB(51,181,229)
	BarBG.Initialize("BarBG")
	base.Color = Colors.Transparent
	base.AddView(BarBG,0,0,base.Width,base.Height)
	Rangebar.Initialize("")
	BarBG.AddView(Rangebar,0,0,1,1)

	'Set orientation
	If BarBG.Width >= BarBG.Height Then BarBGOrient = False Else BarBGOrient = True
	NumPtrs = 3
	IsEnabled = True

	index=0
	For k=0 To NumPtrs-1
		Ptr(k).Initialize("Ptr")	
	Next
		
	'Initialize ptr size based on Orientation
	For k=0 To NumPtrs-1
		If BarBGOrient Then	'Vertical
			BarBG.AddView(Ptr(k),0,0,BarBG.Width,BarBG.Width)
		Else
			BarBG.AddView(Ptr(k),0,0,BarBG.Height,BarBG.Height)
		End If	
		PtrPos(k) = 0
		MovePtr(k, 0.5)
	Next
		
	CreatePointers
	SetMaxVal(100)
	SetValue2(0,0)
	SetValue2(1,50)
	SetValue2(2,100)

End Sub

Sub CreatePointers

	'Initialize Panels
	Rangebar.Color = SliderColor

	If MaxVal = 0 Then
		MaxVal = 100
		PtrPos(0) = 0
		If NumPtrs > 2 Then PtrPos(1) = MaxVal / 2
		PtrPos(NumPtrs-1) = MaxVal
	End If
	
	Dim Rect1 As Rect
	Dim cvv As Canvas
	Dim r, w As Int
	r = (Ptr(0).Width/2)
	If BarBGOrient Then
		w = BarBG.Width * 0.03
	Else
		w = BarBG.Height * 0.03
	End If
	cvv.Initialize(BarBG)	
	Rect1.Initialize(r-w,r-w,BarBG.Width-r+w,BarBG.Height-r+w)		
	cvv.DrawRect(Rect1,Colors.DarkGray,True,0)
	'Default Initializations

	If BarBGOrient Then
		setmaxmovev
		MaxVal = MaxMove
	Else
		setmaxmoveh
		MaxVal = MaxMove
	End If
		
	For k = 0 To 2
		Ptr(k).Visible = (k < NumPtrs)
	Next
	
	InInit = False
	'Initialization completed
	ReDrawSlider
End Sub

Private Sub DrawPointerImage(PointerNbr As Int, PtrColor As Int,Action As Int)
	Dim cvv As Canvas
	Dim Obj1 As Reflector
    Dim argb() As Int
	Dim rad,rad2 As Int
	Dim outercolor As Int
	
	If Not(IsEnabled) Then
		PtrColor = Colors.DarkGray
	End If
	
	rad = Ptr(PointerNbr).Width/2
	If BarBGOrient Then 'vertical, 
		Ptr(PointerNbr).Width = BarBG.Width
		Ptr(PointerNbr).Height = BarBG.Width
	Else
		Ptr(PointerNbr).Width = BarBG.Height
		Ptr(PointerNbr).Height = BarBG.Height
	End If
    argb = GetARGB(PtrColor)
	outercolor = Colors.argb(160,argb(1),argb(2),argb(3))
'	If Action = 2 Then ' PRESSED
'		outercolor = Colors.argb(200,argb(1),argb(2),argb(3))
'		PtrColor = Colors.White
'	End If
	If Action = 1 Then ' FOCUSED
		outercolor = Colors.argb(127,argb(1),argb(2),argb(3))
	End If
	cvv.Initialize(Ptr(PointerNbr))
   	Obj1.Target = cvv
   	Obj1.Target = Obj1.GetField("paint")
   	Obj1.RunMethod2("setAntiAlias", True, "java.lang.boolean")
	cvv.DrawCircle(rad,rad,rad+1,Colors.Transparent,True,1)
	rad2 = rad
	If Not(IsEnabled) Then rad2 = rad * 0.8
	cvv.DrawCircle(rad,rad,rad2,outercolor,True,0)
	If Action = 1 Then 'FOCUSED
		cvv.DrawCircle(rad,rad,rad2-2,PtrColor,False,2)
	End If
	cvv.DrawCircle(rad,rad,rad2 * 0.33,PtrColor,True,0)	
	
End Sub


Private Sub ResizeConnectingLine
	If InInit Then Return
	Dim barrad As Int
	Dim Circlerad As Int
	
	If BarBGOrient Then
		barrad = BarBG.Width * 0.05
	Else
		barrad = BarBG.height * 0.05
	End If
	If IsEnabled Then
		Rangebar.Color = SliderColor		
	Else	
		barrad = barrad * 0.5
		Rangebar.Color = Colors.DarkGray
	End If
	Circlerad = Ptr(0).Height / 2
	
	If (NumPtrs = 1) Then ' draw a line from the left/top edge (+ 1/2 the width of the slider image)
		If Not(ReverseDir) Then
			If BarBGOrient Then 'vertical, single disc
				Rangebar.Left = Circlerad - barrad
				Rangebar.width = barrad * 2
				Rangebar.Top = Circlerad
				Rangebar.Height = Ptr(0).top + 1	' width & height must be at leat 1
			Else 
				Rangebar.Top = Circlerad - barrad
				Rangebar.Height = barrad * 2
				Rangebar.Left = Circlerad
				Rangebar.width = Ptr(0).left + 1 
			End If
		Else  ' Draw the line from bottom up or Left to right
			If BarBGOrient Then 'vertical, single disc
				Rangebar.Left = Circlerad - barrad
				Rangebar.width = barrad * 2
				Rangebar.Top = Ptr(0).top + Circlerad - 1	' width & height must be at leat 1
				Rangebar.height = BarBG.Height - Ptr(0).Top - (Circlerad * 2)
			Else
				Rangebar.Top = Circlerad - barrad
				Rangebar.Height = barrad * 2
				Rangebar.Left = Ptr(0).left + Circlerad - 1
				Rangebar.width = BarBG.Width - Ptr(0).Left - (Circlerad  * 2)
			End If
		End If
	Else 'draw a line between the center of the 1st and last slider
		If BarBGOrient Then	'Vertical
			Rangebar.Left = Ptr(0).Left + (Ptr(0).Width / 2) - barrad
			Rangebar.Top = Ptr(0).Top + (Ptr(0).Height / 2)
			Rangebar.width = barrad * 2
			Rangebar.Height = Ptr(NumPtrs-1).top - Ptr(0).top
		Else
			Rangebar.Left = Ptr(0).Left + (Ptr(0).Width / 2)
			Rangebar.Top = Ptr(0).Top + (Ptr(0).Height / 2) - barrad
			Rangebar.width = Ptr(NumPtrs-1).Left - Ptr(0).left
			Rangebar.Height = barrad * 2
		End If	
	End If
End Sub

'set the Slider color
Sub SetSliderColor(Col As Int)
	SliderColor = Col
	ReDrawSlider
End Sub

'Set the number of pointers
Sub SetPointerCount(val As Int)
	NumPtrs = val
	CreatePointers
	'ReDrawSlider
End Sub

'Set MaxVal Value
Sub SetMaxVal(sMaxVal As Int)
	MaxVal=sMaxVal
End Sub
'Set Current Position (0 - 1) 
Sub SetPos(sValue As Double)
	SetPos2(0,sValue)
	MovePtr(0,PtrPos(0))	'may have changed
End Sub
'Set Current Value *** Set MaxVal first
Sub SetValue (sPos As Double)	'Legacy: index 0
	SetValue2(0,sPos)
	MovePtr(0,PtrPos(0))
End Sub

Sub SetPos2(ptr_index As Int ,sValue As Double)
	If ReverseDir Then
		sValue = 1 - sValue
	End If
	If ptr_index<0 OR ptr_index>=NumPtrs Then Return
	
	Dim k As Int
	For k=0 To ptr_index-1 
		If PtrPos(k)>sValue Then
			PtrPos(k)=sValue
			MovePtr(k,sValue)
		End If
	Next
	For k=ptr_index+1 To NumPtrs-1 
		If PtrPos(k)<sValue Then
			PtrPos(k)=sValue
			MovePtr(k,sValue)
		End If
	Next
	
	PtrPos(ptr_index)=sValue
	MovePtr(ptr_index,sValue)
	
End Sub
'Set Current Value *** Set MaxVal first
Sub SetValue2 (ptr_index As Int, sPos As Double)

	If ptr_index<0 OR ptr_index>=NumPtrs Then Return
	
	If ptr_index=NumPtrs-1 Then 'Only at the end xq if you update the first value, return an event with values above the second and third
		permis_callsub=True
	Else
		permis_callsub=False
	End If
	
	SetPos2(ptr_index, sPos/MaxVal)

	permis_callsub=True
End Sub

Private Sub BarBG_touch (Action As Int, X0 As Float, Y0 As Float)

	Dim new_pos As Float

	Dim Y As Float = Y0-CY_INI
	Dim X As Float = X0-CX_INI

	If Action = 0 Then  'ACTION_DOWN
		
		' Look for the nearest pointer index
		If NumPtrs=1 Then
			index=0
		Else
			index=0	'start guess
			If BarBGOrient Then
				Dim despY As Float = Y/RECORREGUT	
				'Find the nearest pointer
				For k=1 To NumPtrs-1	'si 
					If Abs(despY -PtrPos(k))<Abs(despY -PtrPos(index)) Then
						index=k
					Else If PtrPos(k)=PtrPos(index) AND PtrPos(k)<despY Then					
						index=k
					End If
				Next			
			Else
				Dim despX As Float = X/RECORREGUT
				For k=1 To NumPtrs-1	
					If Abs(despX -PtrPos(k))<Abs(despX -PtrPos(index)) Then
						index=k
					Else If PtrPos(k)=PtrPos(index) AND PtrPos(k)<despX Then
						index=k
					End If
				Next
			End If
		End If
		
		DrawPointerImage(index,SliderColor,1)
		
		If BarBGOrient Then
			MovePtr(index,Min(Max(0,Y ),MaxMove)/MaxMove)			
		Else
			'BarBG is horizontal
			MovePtr(index,Min(Max(0,X ),MaxMove)/MaxMove)			
		End If
	End If
	If Action = 1 Then 'ACTION_UP
		DrawPointerImage(index,SliderColor,0)
		If SubExists(CF,ISName&"_Released") Then 'ACTION_UP
			CallSub2(CF,ISName&"_Released",GetValue)
			Return
		End If
	End If
	If Action = 2 Then  'ACTION_MOVE
		If BarBGOrient Then

			new_pos = Min(Max(0,Y ),MaxMove)/MaxMove
			If index>0 AND new_pos<PtrPos(index-1) Then
				new_pos = PtrPos(index-1)
			End If
			If index<NumPtrs-1 AND new_pos>PtrPos(index+1) Then
				new_pos = PtrPos(index+1)			
			End If		
			MovePtr(index,new_pos)	
		Else
			'BarBG is horizontal
			new_pos = Min(Max(0,X),MaxMove)/MaxMove
			If index>0 AND new_pos<PtrPos(index-1) Then
				new_pos = PtrPos(index-1)
			End If
			If index<NumPtrs-1 AND new_pos>PtrPos(index+1) Then
				new_pos = PtrPos(index+1)			
			End If
			MovePtr(index,new_pos )
		End If
	End If
End Sub

Private Sub MovePtr(ptr_index As Int, Pos As Double)	'Pos: 0..1

	If IsDiscrete = True Then
		Pos = Round(Pos*MaxVal)/MaxVal
	End If
	
	PtrPos(ptr_index) = Pos
	
	If BarBGOrient Then	'vertical
		Ptr(ptr_index).Top = CY_INI - (Ptr(ptr_index).Height/2) + Pos*MaxMove
	Else
		'Coordinate calculation: pointer central point
		Ptr(ptr_index).Left= CX_INI - (Ptr(ptr_index).Width/2) + Pos*MaxMove
	End If

	If permis_callsub=False Then Return	'Just to prevent multiple callbacks when initting. Can be removed
	
	'Check for call back subs and call id available
	If ptr_index=0 AND SubExists(CF,ISName&"_ValueChanged") Then
			CallSub2(CF,ISName&"_ValueChanged",GetValue)
	End If
	
	If ptr_index=0 AND SubExists(CF,ISName&"_PosChanged") Then
			CallSub2(CF,ISName&"_PosChanged",PtrPos)
	End If
	
	'Added for multipointer
	If SubExists(CF,ISName&"_ValuesChanged") Then
		Dim fVals(NumPtrs) As Float
		For k=0 To NumPtrs-1
			fVals(k)=GetValue2(k)
		Next
		CallSub2(CF,ISName&"_ValuesChanged",fVals)
	End If	
	If SubExists(CF,ISName&"_PossChanged") Then
		CallSub2(CF,ISName&"_PossChanged",PtrPos)
	End If
	ResizeConnectingLine
End Sub

Sub GetSliderColor As Int
	Return SliderColor
End Sub

'Get the calculated value from the InputSlider
Sub GetValue As Float
	If ReverseDir Then
		Return MaxVal - (PtrPos(0)*MaxVal)
	Else
		Return PtrPos(0)*MaxVal
	End If
End Sub

'Returns position as float range 0-1
Sub GetPos As Float
	If ReverseDir Then
		Return 1 - PtrPos(0)
	Else
		Return PtrPos(0)
	End If	
End Sub

'Get the calculated value from the InputSlider
Sub GetValue2(ptr_index As Int) As Float
	If ReverseDir Then
	Return MaxVal - (PtrPos(ptr_index)*MaxVal)
	Else
	Return PtrPos(ptr_index)*MaxVal
	End If
End Sub

'Returns position as float range 0-1
Sub GetPos2(ptr_index As Int) As Float
	If ReverseDir Then
	Return 1 - PtrPos(ptr_index)
	Else
	Return PtrPos(ptr_index)
	End If
End Sub

Private Sub setmaxmovev
	'Determine maximum move allowed
	'MaxMove=BarBG.Height-Ptr.Height
	CY_INI=FACTOR_PTR*Ptr(0).Height/2
	CY_END = BarBG.Height-FACTOR_PTR*Ptr(0).Height/2
	RECORREGUT = CY_END-CY_INI
	MaxMove=RECORREGUT	
End Sub

Private Sub setmaxmoveh
	'Determine maximum move allowed
	'MaxMove=BarBG.Width-Ptr.Width
	CX_INI=FACTOR_PTR*Ptr(0).Width/2
	CX_END = BarBG.Width-FACTOR_PTR*Ptr(0).Width/2
	RECORREGUT = CX_END-CX_INI
	MaxMove=RECORREGUT
End Sub

Sub GetVersion As String
	Return Version
End Sub

Private Sub GetARGB(Color As Int) As Int()
    Dim res(4) As Int
    res(0) = Bit.UnsignedShiftRight(Bit.AND(Color, 0xff000000), 24)
    res(1) = Bit.UnsignedShiftRight(Bit.AND(Color, 0xff0000), 16)
    res(2) = Bit.UnsignedShiftRight(Bit.AND(Color, 0xff00), 8)
    res(3) = Bit.AND(Color, 0xff)
    Return res
End Sub

Sub SetEnabled(val As Boolean)
	IsEnabled = val
	ReDrawSlider
End Sub

Sub SetDiscrete(val As Boolean)
	IsDiscrete = val
	ReDrawSlider
End Sub

Sub SetReverse(val As Boolean)
	ReverseDir = val
	ReDrawSlider
End Sub

Private Sub ReDrawSlider
	BarBG.Enabled = IsEnabled
	Rangebar.Enabled = IsEnabled
	For i = 0 To Ptr.Length-1
		If Ptr(i).IsInitialized Then
			Ptr(i).Enabled = IsEnabled
			DrawPointerImage(i,SliderColor,0)
			End If
	Next
	ResizeConnectingLine
End Sub

